Index: issm/trunk/src/c/shared/MemOps/MemOps.h
===================================================================
--- issm/trunk/src/c/shared/MemOps/MemOps.h	(revision 25994)
+++ issm/trunk/src/c/shared/MemOps/MemOps.h	(revision 26744)
@@ -7,4 +7,5 @@
 
 #include <cassert>
+#include <cstring> /*for memcpy*/
 
 /* memory management of types T with non-trivial constructors require C++ style memory management*/
@@ -68,6 +69,5 @@
   T* aT_p=xNew<T>(size);
 #endif
-  for (unsigned int i=0; i<size;++i) 
-    aT_p[i]=(T)0;
+  for(unsigned int i=0; i<size;++i) aT_p[i]=(T)0;
   return aT_p;
 #else
@@ -80,6 +80,5 @@
 #ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
   T** aT_pp=xNew<T>(dim1,dim2);
-  for (unsigned int i=0; i<dim1*dim2;++i)
-    (*aT_pp)[i]=(T)0;
+  for (unsigned int i=0; i<dim1*dim2;++i) (*aT_pp)[i]=(T)0;
   return aT_pp;
 #else
@@ -152,6 +151,9 @@
 template <class T>  T* xMemCpy(T* dest, const T* src, unsigned int size) {/*{{{*/
   assert(dest); assert(src);
-  for (int i=0; i<size;++i) 
-    dest[i]=src[i];
+  #if defined(_HAVE_ADOLC_)
+  for (int i=0; i<size;++i) dest[i]=src[i];
+  #else
+  memcpy(dest,src,size*sizeof(T));
+  #endif
   return dest;
 };
Index: issm/trunk/src/c/shared/Numerics/types.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/types.h	(revision 25994)
+++ issm/trunk/src/c/shared/Numerics/types.h	(revision 26744)
@@ -13,4 +13,5 @@
 
 #include <stdio.h>
+#include <complex>
 
 /*here are our abstracted types: inspired on petsc */
@@ -24,17 +25,24 @@
 /*ADOLC typedefs*/
 #include "adolc/adolc.h"
-typedef adouble IssmDouble; /*for active variables*/
-typedef double  IssmPDouble; /*for passive variables*/
+typedef adouble              IssmDouble;  /*for active variables*/
+//typedef acomplex             IssmComplex; /*for active variables*/ /*FIXME!*/
+typedef std::complex<double> IssmComplex; /*for active variables*/ /*FIXME!*/
+typedef double               IssmPDouble; /*for passive variables*/
+typedef std::complex<double> IssmPComplex;/*for passive variables*/
 
 #elif defined(_HAVE_CODIPACK_) && !defined(_WRAPPERS_)
 /*CoDiPack typedefs*/
 #include <codi.hpp>
-typedef codi::RealReverse IssmDouble;
-typedef double            IssmPDouble;
+typedef codi::RealReverse               IssmDouble;
+typedef std::complex<codi::RealReverse> IssmComplex;
+typedef double                          IssmPDouble;
+typedef IssmComplex                     IssmPComplex;
 
+#else 
 /*Non-AD typedefs*/
-#else 
-typedef double     IssmDouble; 
-typedef IssmDouble IssmPDouble;
+typedef double               IssmDouble; 
+typedef std::complex<double> IssmComplex; 
+typedef IssmDouble           IssmPDouble;
+typedef IssmComplex          IssmPComplex;
 #endif
 
Index: issm/trunk/src/c/shared/Random/random.cpp
===================================================================
--- issm/trunk/src/c/shared/Random/random.cpp	(revision 26744)
+++ issm/trunk/src/c/shared/Random/random.cpp	(revision 26744)
@@ -0,0 +1,99 @@
+/*!\file: random
+ * \brief random number generating functions
+ */ 
+
+/*Headers*/
+/*{{{*/
+#include <stdio.h>
+#include <sys/types.h>
+#include <math.h>
+#include <float.h>    /*  DBL_EPSILON  */
+#include <cstdarg>
+#include <iostream>
+
+#include "../Matrix/matrix.h"
+#include "../Exceptions/exceptions.h"
+#include "../MemOps/MemOps.h"
+#include "../io/io.h"
+#include "./randomgenerator.h"
+/*}}}*/
+
+void univariateNormal(IssmPDouble* prand, IssmPDouble mean, IssmPDouble sdev, int seed=-1) { /*{{{*/
+
+	/*Seed the pseudo-random number generator*/
+	rnd::linear_congruential_engine randomengine;
+	randomengine.seed(seed);
+	/*Normal distribution*/
+	rnd::normal_distribution distriNormal(mean,sdev);
+	/*Assign output pointer and cleanup*/
+	*prand = distriNormal.generator(randomengine);
+	randomengine.free_resources();
+} /*}}}*/
+void multivariateNormal(IssmDouble** prand, int dim, IssmDouble mean, IssmDouble* covariancematrix, int seed=-1) { /*{{{*/
+   
+	IssmPDouble* sampleStandardNormal    = xNew<IssmPDouble>(dim);
+   IssmDouble* sampleMultivariateNormal = xNew<IssmDouble>(dim);
+   IssmDouble* Lchol                    = xNewZeroInit<IssmDouble>(dim*dim);
+
+	/*True randomness if seed<0, otherwise random seed is fixed at seed*/
+	/*Seed the pseudo-random number generator, repeatedly calling univariateNormal does not ensure randomness*/
+	rnd::linear_congruential_engine randomengine;
+	randomengine.seed(seed);
+	/*Normal distribution*/
+	rnd::normal_distribution distriNormal(0.0,1.0);
+	for(int i=0;i<dim;i++){
+		sampleStandardNormal[i] = distriNormal.generator(randomengine);
+	}
+
+	/*Cholsesky decomposition of the covariance matrix*/
+	CholeskyRealPositiveDefinite(Lchol,covariancematrix,dim);
+   
+	/*Matrix by vector multiplication*/
+	for(int i=0;i<dim;i++){ 
+      /*Entry-by-entry multiplication along matrix row*/
+      IssmDouble sum=0.;
+      for(int j=0;j<dim;j++) sum += sampleStandardNormal[j]*Lchol[i*dim+j]; 
+      sampleMultivariateNormal[i] = mean+sum;
+   }
+
+   /*Assign output pointer and cleanup*/
+   *prand = sampleMultivariateNormal;
+   xDelete<IssmPDouble>(sampleStandardNormal);
+   xDelete<IssmDouble>(Lchol);
+	randomengine.free_resources();
+} /*}}}*/
+void multivariateNormal(IssmDouble** prand, int dim, IssmDouble* mean, IssmDouble* covariancematrix, int seed=-1) { /*{{{*/
+	
+	IssmPDouble* sampleStandardNormal    = xNew<IssmPDouble>(dim);
+	IssmDouble* sampleMultivariateNormal = xNew<IssmDouble>(dim);
+	IssmDouble* Lchol                    = xNewZeroInit<IssmDouble>(dim*dim);
+	
+	/*True randomness if seed<0, otherwise random seed is fixed at seed*/
+	/*Seed the pseudo-random number generator, repeatedly calling univariateNormal does not ensure randomness*/
+	rnd::linear_congruential_engine randomengine;
+	randomengine.seed(seed);
+	/*Normal distribution*/
+	rnd::normal_distribution distriNormal(0.0,1.0);
+	for(int i=0;i<dim;i++){
+		sampleStandardNormal[i] = distriNormal.generator(randomengine);
+	}
+
+	/*Cholsesky decomposition of the covariance matrix*/
+	CholeskyRealPositiveDefinite(Lchol,covariancematrix,dim);
+
+	/*Matrix by vector multiplication*/
+	for(int i=0;i<dim;i++){
+		IssmDouble sum = 0.;
+      for(int j=0;j<dim;j++) sum += sampleStandardNormal[j]*Lchol[i*dim+j]; 
+      sampleMultivariateNormal[i] = mean[i]+sum;
+	}
+   
+	/*Assign output pointer and cleanup*/
+	*prand = sampleMultivariateNormal;
+	xDelete<IssmPDouble>(sampleStandardNormal);
+	xDelete<IssmDouble>(Lchol);
+	randomengine.free_resources();
+} /*}}}*/
+
+
+
Index: issm/trunk/src/c/shared/Random/random.h
===================================================================
--- issm/trunk/src/c/shared/Random/random.h	(revision 26744)
+++ issm/trunk/src/c/shared/Random/random.h	(revision 26744)
@@ -0,0 +1,12 @@
+/*!\file: random.h
+ * \brief prototypes for random.h
+ */ 
+
+#ifndef _RANDOM_H_
+#define _RANDOM_H_
+
+void univariateNormal(IssmDouble* prand, IssmDouble mean, IssmDouble sdev, int seed=-1);
+void multivariateNormal(IssmDouble** prand, int dim, IssmDouble mean, IssmDouble* covariancematrix, int seed=-1);
+void multivariateNormal(IssmDouble** prand, int dim, IssmDouble* mean, IssmDouble* covariancematrix, int seed=-1);
+
+#endif //ifndef _RANDOM_H_
Index: issm/trunk/src/c/shared/Random/randomgenerator.cpp
===================================================================
--- issm/trunk/src/c/shared/Random/randomgenerator.cpp	(revision 26744)
+++ issm/trunk/src/c/shared/Random/randomgenerator.cpp	(revision 26744)
@@ -0,0 +1,222 @@
+/*!\file: randomgenerator
+ * \brief random number generating functions
+ */
+
+#include <iostream>
+#include "./randomgenerator.h"
+#include <cmath>
+#include <chrono>
+
+#undef M_PI
+#define M_PI 3.141592653589793238462643
+
+namespace rnd{
+
+  /* Linear congruential engine */
+
+  linear_congruential_engine::linear_congruential_engine(){/*{{{*/
+
+      pseed = new unsigned int;
+			*pseed = std::chrono::steady_clock::now().time_since_epoch()/std::chrono::milliseconds(1);
+      a = 1103515245;		       // BSD Formula
+      c = 12345;					     // BSD Formula
+      m = 2147483648;			     // BSD Formula
+			return;
+	}/*}}}*/
+
+  linear_congruential_engine::linear_congruential_engine(unsigned int _a, unsigned int _b, unsigned int _m){/*{{{*/
+
+      pseed = new unsigned int;
+			*pseed = std::chrono::steady_clock::now().time_since_epoch()/std::chrono::milliseconds(1);
+      a = _a;
+      c = _b;
+      m = _m;
+			return;
+	}/*}}}*/
+
+	linear_congruential_engine::~linear_congruential_engine(){}
+
+  unsigned int linear_congruential_engine::get_m() { return m; }
+
+  void linear_congruential_engine::seed( int s ) {
+      if(s<0)
+        *pseed = std::chrono::steady_clock::now().time_since_epoch()/std::chrono::milliseconds(1);
+      else
+        *pseed = (unsigned) s;
+  }
+
+  unsigned int linear_congruential_engine::generator(){
+    *pseed = ( a * *pseed + c ) % m ;
+    return *pseed;
+  }
+
+  void linear_congruential_engine::free_resources(){
+	  delete pseed;
+	  return;
+  }
+
+  /* Uniform distribution */
+
+	uniform_distribution::uniform_distribution(){/*{{{*/
+			a = 0.0;
+			b = 1.0;
+			return;
+	}
+	/*}}}*/
+
+	uniform_distribution::uniform_distribution(double _a,double _b){/*{{{*/
+			a = _a;
+			b = _b;
+			return;
+	}
+	/*}}}*/
+
+	uniform_distribution::~uniform_distribution(){}
+
+	double uniform_distribution::generator(rnd::linear_congruential_engine random_engine) {
+			return (b-a)*(double) random_engine.generator()/ random_engine.get_m() + a;
+	}
+
+  /* Normal distribution */
+
+	normal_distribution::normal_distribution(){/*{{{*/
+			mean   = 0;
+			sdev  = 1.0;
+			return;
+	}
+	/*}}}*/
+
+	normal_distribution::normal_distribution(double m,double s){/*{{{*/
+			mean   = m;
+			sdev  = s;
+			return;
+	}
+	/*}}}*/
+
+	normal_distribution::~normal_distribution(){}
+
+	double normal_distribution::generator(rnd::linear_congruential_engine random_engine){/*{{{*/
+
+			rnd::uniform_distribution	distribution;
+
+			double u1 = distribution.generator(random_engine);
+			double u2 = distribution.generator(random_engine);
+
+			double R = sqrt(-2*log(u1));
+			double theta = 2*M_PI*u2;
+
+			return mean + sdev * (R*cos(theta));
+
+	}
+	/*}}}*/
+
+  /* Log-Normal distribution */
+
+  lognormal_distribution::lognormal_distribution(){/*{{{*/
+      logmean   = 0;
+      logsdev  = 1.0;
+      return;
+  }
+  /*}}}*/
+
+  lognormal_distribution::lognormal_distribution(double m,double s){/*{{{*/
+      logmean   = m;
+      logsdev  = s;
+      return;
+  }
+  /*}}}*/
+
+  lognormal_distribution::~lognormal_distribution(){}
+
+  double lognormal_distribution::generator(rnd::linear_congruential_engine random_engine){/*{{{*/
+
+      rnd::normal_distribution	distribution(logmean,logsdev);
+
+      return exp(distribution.generator(random_engine));
+
+  }
+  /*}}}*/
+
+  /* Chi-squared distribution */
+
+  chi_squared_distribution::chi_squared_distribution(){/*{{{*/
+      k  = 1;
+      return;
+  }
+  /*}}}*/
+
+  chi_squared_distribution::chi_squared_distribution(unsigned int dof){/*{{{*/
+      k   = dof;
+      return;
+  }
+  /*}}}*/
+
+  chi_squared_distribution::~chi_squared_distribution(){}
+
+  double chi_squared_distribution::generator(rnd::linear_congruential_engine random_engine){/*{{{*/
+
+      rnd::normal_distribution	distribution;
+
+      double rand = 0;
+
+      for(int i=0;i<k;i++)
+        rand = rand + pow(distribution.generator(random_engine),2);
+
+      return rand;
+
+  }
+  /*}}}*/
+
+
+  /* Exponential distribution */
+
+  exponential_distribution::exponential_distribution(){/*{{{*/
+      lambda  = 1.0;
+      return;
+  }
+  /*}}}*/
+
+  exponential_distribution::exponential_distribution(double scale){/*{{{*/
+      lambda   = scale;
+      return;
+  }
+  /*}}}*/
+
+  exponential_distribution::~exponential_distribution(){}
+
+  double exponential_distribution::generator(rnd::linear_congruential_engine random_engine){/*{{{*/
+
+      rnd::uniform_distribution	distribution;
+
+      return -1.0/lambda*log(1.0-distribution.generator(random_engine));
+
+  }
+  /*}}}*/
+
+  /* Student-t distribution */
+
+  student_t_distribution::student_t_distribution(){/*{{{*/
+      k  = 1;
+      return;
+  }
+  /*}}}*/
+
+  student_t_distribution::student_t_distribution(unsigned int dof){/*{{{*/
+      k   = dof;
+      return;
+  }
+  /*}}}*/
+
+  student_t_distribution::~student_t_distribution(){}
+
+  double student_t_distribution::generator(rnd::linear_congruential_engine random_engine){/*{{{*/
+
+      rnd::normal_distribution	normal_distribution;
+      rnd::chi_squared_distribution	chi_squared_distribution(k);
+
+      return normal_distribution.generator(random_engine)/sqrt(chi_squared_distribution.generator(random_engine)/k);
+
+  }
+  /*}}}*/
+
+}
Index: issm/trunk/src/c/shared/Random/randomgenerator.h
===================================================================
--- issm/trunk/src/c/shared/Random/randomgenerator.h	(revision 26744)
+++ issm/trunk/src/c/shared/Random/randomgenerator.h	(revision 26744)
@@ -0,0 +1,142 @@
+/*!\file: randomgenerator.h
+ * \brief prototypes for randomgenerator.h
+ */
+
+#ifndef _RANDOMGENERATOR_H_
+#define _RANDOMGENERATOR_H_
+
+#undef M_PI
+#define M_PI 3.141592653589793238462643
+
+namespace rnd{
+
+  class linear_congruential_engine
+  {
+    private:
+      unsigned int a;
+      unsigned int c;
+      unsigned int m;
+      unsigned int *pseed;
+
+    public:
+
+      /*constructors, destructors: */
+      linear_congruential_engine();
+      linear_congruential_engine(unsigned int _a, unsigned int _b, unsigned int _m);
+      ~linear_congruential_engine();
+
+      unsigned int get_m();
+      void seed( int s );
+      unsigned int generator();
+		void free_resources();
+  };
+
+  class uniform_distribution
+  {
+
+    private:
+      double a;  // lower bound of range
+      double b;  // upper bound of range
+
+    public:
+
+      /*constructors, destructors: */
+      uniform_distribution();
+      uniform_distribution(double _a,double _b);
+      ~uniform_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+  class normal_distribution
+  {
+
+    private:
+      double mean;
+      double sdev;
+
+    public:
+
+      /*constructors, destructors: */
+      normal_distribution();
+      normal_distribution(double m,double s);
+      ~normal_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+  class lognormal_distribution
+  {
+
+    private:
+      double logmean;
+      double logsdev;
+
+    public:
+
+      /*constructors, destructors: */
+      lognormal_distribution();
+      lognormal_distribution(double m,double s);
+      ~lognormal_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+  class chi_squared_distribution
+  {
+
+    private:
+      unsigned int k;
+
+    public:
+
+      /*constructors, destructors: */
+      chi_squared_distribution();
+      chi_squared_distribution(unsigned int k);
+      ~chi_squared_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+  class exponential_distribution
+  {
+
+    private:
+      double lambda;
+
+    public:
+
+      /*constructors, destructors: */
+      exponential_distribution();
+      exponential_distribution(double scale);
+      ~exponential_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+  class student_t_distribution
+  {
+
+    private:
+      unsigned int k;
+
+    public:
+
+      /*constructors, destructors: */
+      student_t_distribution();
+      student_t_distribution(unsigned int k);
+      ~student_t_distribution();
+
+      double generator(rnd::linear_congruential_engine random_engine);
+
+  };
+
+
+}
+
+#endif //* _RANDOMGENERATOR_H_ */
Index: issm/trunk/src/c/shared/io/Comm/IssmComm.cpp
===================================================================
--- issm/trunk/src/c/shared/io/Comm/IssmComm.cpp	(revision 25994)
+++ issm/trunk/src/c/shared/io/Comm/IssmComm.cpp	(revision 26744)
@@ -12,4 +12,9 @@
 #include "../../Numerics/types.h"
 #include "../../Exceptions/exceptions.h"
+
+#ifdef _DO_NOT_LOAD_GLOBALS_
+ISSM_MPI_Comm	IssmComm::comm;
+bool			IssmComm::parallel;
+#endif
 
 void IssmComm::SetComm(ISSM_MPI_Comm incomm){ /*{{{*/
Index: issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp
===================================================================
--- issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp	(revision 25994)
+++ issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp	(revision 26744)
@@ -121,4 +121,9 @@
 		const char* field = "md.friction.coefficient";
 		input_enum        = FrictionCoefficientEnum;
+		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
+	}
+	else if(strcmp(string_in,"FrictionC")==0 || strcmp(string_in,"md.friction.C")==0){
+		const char* field = "md.friction.C";
+		input_enum        = FrictionCEnum;
 		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
 	}
@@ -163,7 +168,7 @@
 		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
 	}
-	else if(strcmp(string_in,"SurfaceloadIceThicknessChange")==0){
-		const char* field = "md.solidearth.surfaceload.icethicknesschange";
-		input_enum        = SurfaceloadIceThicknessChangeEnum;
+	else if(strcmp(string_in,"IceLoad")==0){
+		const char* field = "md.masstransport.spcthickness";
+		input_enum        = MasstransportSpcthicknessEnum;
 		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
 	}
@@ -173,12 +178,22 @@
 		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
 	}
-	else if(strcmp(string_in,"DslGlobalAverageThermostericSeaLevelChange")==0){
-		const char* field = "md.dsl.global_average_thermosteric_sea_level_change";
-		input_enum        = DslGlobalAverageThermostericSeaLevelChangeEnum;
-		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
-	}
-	else if(strcmp(string_in,"SurfaceloadWaterHeightChange")==0){
-		const char* field = "md.solidearth.surfaceload.waterheightchange";
-		input_enum        = SurfaceloadWaterHeightChangeEnum;
+	else if(strcmp(string_in,"DslGlobalAverageThermostericSeaLevel")==0){
+		const char* field = "md.dsl.global_average_thermosteric_sea_level";
+		input_enum        = OceantransportSpcstrEnum;
+		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
+	}
+	else if(strcmp(string_in,"DslSeaWaterPressureAtSeaFloor")==0){
+		const char* field = "md.dsl.sea_water_pressure_at_sea_floor";
+		input_enum        = OceantransportSpcbottompressureEnum;
+		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
+	}
+	else if(strcmp(string_in,"DslSeaSurfaceHeightAboveGeoid")==0){
+		const char* field = "md.dsl.sea_surface_height_above_geoid";
+		input_enum        = OceantransportSpcdslEnum;
+		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
+	}
+	else if(strcmp(string_in,"TwsLoad")==0){
+		const char* field = "md.hydrology.spcwatercolumn";
+		input_enum        = HydrologyTwsSpcEnum;
 		fieldname=xNew<char>((strlen(field)+1)); xMemCpy<char>(fieldname,field,(strlen(field)+1));
 	}
@@ -226,4 +241,5 @@
 		case 11: return SMBgradientscomponentsEnum;
 		case 12: return SMBsemicEnum;	
+		case 55: return SMBautoregressionEnum;
 		default: _error_("Marshalled SMB code \""<<enum_in<<"\" not supported yet");
 	}
@@ -258,4 +274,5 @@
 		case 1: return FrontalForcingsDefaultEnum;
 		case 2: return FrontalForcingsRignotEnum;
+		case 55: return FrontalForcingsRignotAutoregressionEnum;
 		default: _error_("Marshalled Frontalforcings code \""<<enum_in<<"\" not supported yet");
 	}
@@ -268,4 +285,5 @@
 		case 4: return HydrologypismEnum;
 		case 5: return HydrologyGlaDSEnum;
+		case 6: return HydrologyTwsEnum;
 		default: _error_("Marshalled hydrology code \""<<enum_in<<"\" not supported yet");
 	}
@@ -307,4 +325,12 @@
 		case 2: return AmrNeopzEnum;
 		default: _error_("Marshalled AMR code \""<<enum_in<<"\" not supported yet");
+	}
+}/*}}}*/
+int IoCodeToEnumGrd(int enum_in){/*{{{*/
+	switch(enum_in){
+		case 0: return NoneEnum;
+		case 1: return ElasticEnum;
+		case 2: return IvinsEnum;
+		default: _error_("Marshalled GRD code \""<<enum_in<<"\" not supported yet");
 	}
 }/*}}}*/
Index: issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.h
===================================================================
--- issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.h	(revision 25994)
+++ issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.h	(revision 26744)
@@ -13,4 +13,5 @@
 int IoCodeToEnumTimestepping(int enum_in);
 int IoCodeToEnumAmr(int enum_in);
+int IoCodeToEnumGrd(int enum_in);
 
 int IoCodeToEnumVertexEquation(int enum_in);
Index: issm/trunk/src/c/shared/io/Marshalling/Marshalling.cpp
===================================================================
--- issm/trunk/src/c/shared/io/Marshalling/Marshalling.cpp	(revision 25994)
+++ issm/trunk/src/c/shared/io/Marshalling/Marshalling.cpp	(revision 26744)
@@ -10,4 +10,5 @@
 
 #include "./Marshalling.h"
+#include "../../Numerics/isnan.h"
 
 WriteCheckpointFunctor::WriteCheckpointFunctor(char** pmarshalled_data_in) : MarshallHandle(MARSHALLING_WRITE){/*{{{*/
@@ -75,5 +76,12 @@
 	this->identifiers  = identifiers_in;
 	this->size_max         = size_max_in;
+	#if _CODIPACK_MAJOR_==2
+	this->tape_codi    = &(IssmDouble::getTape());
+	#elif _CODIPACK_MAJOR_==1
 	this->tape_codi    = &(IssmDouble::getGlobalTape());
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 }/*}}}*/
 void RegisterInputFunctor::Echo(void){/*{{{*/
@@ -83,6 +91,14 @@
 void RegisterInputFunctor::call(IssmDouble & value){/*{{{*/
 	_assert_(this->double_count<size_max);
+	_assert_(!xIsNan<IssmDouble>(value));
 	this->tape_codi->registerInput(value);
+	#if _CODIPACK_MAJOR_==2
+	this->identifiers[this->double_count] = value.getIdentifier();
+	#elif _CODIPACK_MAJOR_==1
 	this->identifiers[this->double_count] = value.getGradientData();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
+
 	this->double_count++;
 }/*}}}*/
@@ -91,6 +107,14 @@
 		for(int i=0;i<size;i++){
 			_assert_(this->double_count<size_max);
+			_assert_(!xIsNan<IssmDouble>(value[i]));
 			this->tape_codi->registerInput(value[i]);
+			#if _CODIPACK_MAJOR_==2
+			this->identifiers[this->double_count] = value[i].getIdentifier();
+			#elif _CODIPACK_MAJOR_==1
 			this->identifiers[this->double_count] = value[i].getGradientData();
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 			this->double_count++;
 		}
@@ -100,5 +124,11 @@
 RegisterOutputFunctor::RegisterOutputFunctor(void) : MarshallHandle(AD_REGISTEROUTPUT){/*{{{*/
 	this->double_count = 0;
+	#if _CODIPACK_MAJOR_==2
+	this->tape_codi    = &(IssmDouble::getTape());
+	#elif _CODIPACK_MAJOR_==1
 	this->tape_codi    = &(IssmDouble::getGlobalTape());
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
 }/*}}}*/
 void RegisterOutputFunctor::Echo(void){/*{{{*/
@@ -107,4 +137,5 @@
 }/*}}}*/
 void RegisterOutputFunctor::call(IssmDouble & value){/*{{{*/
+	_assert_(!xIsNan<IssmDouble>(value));
 	this->tape_codi->registerOutput(value);
 	this->double_count++;
@@ -113,4 +144,5 @@
 	if(value){
 		for(int i=0;i<size;i++){
+			_assert_(!xIsNan<IssmDouble>(value[i]));
 			this->tape_codi->registerOutput(value[i]);
 			this->double_count++;
@@ -121,7 +153,13 @@
 SetAdjointFunctor::SetAdjointFunctor(double* adjoint_in,int size_max_in) : MarshallHandle(AD_SETADJOINT){/*{{{*/
 	this->double_count = 0;
-	this->tape_codi    = &(IssmDouble::getGlobalTape());
 	this->adjoint      = adjoint_in;
 	this->size_max     = size_max_in;
+	#if _CODIPACK_MAJOR_==2
+	this->tape_codi    = &(IssmDouble::getTape());
+	#elif _CODIPACK_MAJOR_==1
+	this->tape_codi    = &(IssmDouble::getGlobalTape());
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
 }/*}}}*/
 void SetAdjointFunctor::Echo(void){/*{{{*/
@@ -131,4 +169,5 @@
 void SetAdjointFunctor::call(IssmDouble & value){/*{{{*/
 	_assert_(this->double_count<size_max);
+	_assert_(!xIsNan<IssmDouble>(this->adjoint[this->double_count]));
 	value.gradient() = this->adjoint[this->double_count];
 	this->double_count++;
@@ -138,4 +177,5 @@
 		for(int i=0;i<size;i++){
 			_assert_(this->double_count<size_max);
+			_assert_(!xIsNan<IssmDouble>(this->adjoint[this->double_count]));
 			value[i].gradient() = this->adjoint[this->double_count];
 			this->double_count++;
Index: issm/trunk/src/c/shared/io/Marshalling/Marshalling.h
===================================================================
--- issm/trunk/src/c/shared/io/Marshalling/Marshalling.h	(revision 25994)
+++ issm/trunk/src/c/shared/io/Marshalling/Marshalling.h	(revision 26744)
@@ -108,4 +108,11 @@
 };/*}}}*/
 #if defined(_HAVE_CODIPACK_) && !defined(_WRAPPERS_)
+#if _CODIPACK_MAJOR_==2
+using Tape = typename IssmDouble::Tape;
+#elif _CODIPACK_MAJOR_==1
+using Tape = typename IssmDouble::TapeType;
+#else
+#error "_CODIPACK_MAJOR_ not supported"
+#endif
 class CountDoublesFunctor:    public MarshallHandle{ /*{{{*/
 
@@ -128,5 +135,5 @@
 		int *identifiers;
 		int  size_max;
-		IssmDouble::TapeType *tape_codi;
+		Tape *tape_codi;
 
 	public:
@@ -142,5 +149,5 @@
 	private:
 		int   double_count;
-		IssmDouble::TapeType* tape_codi;
+		Tape *tape_codi;
 
 	public:
@@ -155,8 +162,8 @@
 
 	private:
-		int                   double_count;
-		int                   size_max;
-		IssmDouble::TapeType* tape_codi;
-		double*               adjoint;
+		int     double_count;
+		int     size_max;
+		Tape   *tape_codi;
+		double *adjoint;
 
 	public:
Index: issm/trunk/src/c/shared/io/Print/PrintfFunction.cpp
===================================================================
--- issm/trunk/src/c/shared/io/Print/PrintfFunction.cpp	(revision 25994)
+++ issm/trunk/src/c/shared/io/Print/PrintfFunction.cpp	(revision 26744)
@@ -32,4 +32,6 @@
 		#ifdef _HAVE_ANDROID_JNI_
 		__android_log_print(ANDROID_LOG_INFO, "Native",message.c_str());
+		#elif _IS_MSYS2_
+		printf("%s",message.c_str());
 		#else
 		ApiPrintf(message.c_str());
@@ -42,4 +44,6 @@
 	#ifdef _HAVE_ANDROID_JNI_
 	__android_log_print(ANDROID_LOG_INFO, "Native",message.c_str());
+	#elif _IS_MSYS2_
+	printf("%s",message.c_str());
 	#else
 	ApiPrintf(message.c_str());
Index: issm/trunk/src/c/solutionsequences/solutionsequence_fct.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_fct.cpp	(revision 25994)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_fct.cpp	(revision 26744)
@@ -418,4 +418,5 @@
 			danalysis->MassMatrix(&Mc,femmodel);
 			danalysis->FctKMatrix(&K,NULL,femmodel);
+			danalysis->FctPVector(&p,femmodel);
 			break;
 		default: _error_("analysis type " << EnumToStringx(analysis_type) << " not supported for FCT\n");
